 
#include <iostream>
#include <string>

namespace pruTempl {
  const unsigned int MAXVECTOR = 10;

  template <class T,unsigned int MAXITEMS = MAXVECTOR>
   class Tvector {
      protected:
        T vect[MAXITEMS];
      public:
        T &  dev_Item(const int x)                  { return vect[x]; };
        void pon_Item(const T & x,const int n)      { vect[n] = x;    };
   };

   class Trec {
   public:
        int edad;
        std::string nombre;
   };
};

using namespace std;
int main(void)
{
      const unsigned int MAX = 5;
      pruTempl::Trec reg;
      reg.nombre = "Juan Nadie";
      pruTempl::Tvector<float>      vectReal;
      pruTempl::Tvector<pruTempl::Trec, MAX> *vectRec;
      vectRec = new pruTempl::Tvector<pruTempl::Trec,MAX>;

      for (unsigned int i = 0; i<pruTempl::MAXVECTOR;i++)
        vectReal.pon_Item(static_cast<float>(i*2),i);

      for (unsigned int i = 0; i<MAX; i++)
      {
        reg.edad = i*2;
        vectRec->pon_Item(reg,i); 
      }

      for (unsigned int i = 0;i<pruTempl::MAXVECTOR;i++)
      {
        cout << vectReal.dev_Item(i);
        if (i<MAX)
        {
                reg = vectRec->dev_Item(i);
                cout << ',' << reg.nombre << " de "
                     << reg.edad << " aos.";
        }
        cout << endl;
      }
    
}
